%% corelib.typ
%% this is used to defined the layouts of the clauses and other low level
%% definitions
%% Copyright (C) 2001,2002 INRIA Emmanuel Coquery

%% This library is free software; you can redistribute it and/or
%% modify it under the terms of the GNU Lesser General Public
%% License as published by the Free Software Foundation; either
%% version 2.1 of the License, or (at your option) any later version.

%% This library is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%% Lesser General Public License for more details.

%% You should have received a copy of the GNU Lesser General Public
%% License along with this library; if not, write to the Free Software
%% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                           %%
%%                                   TCLP                                    %%
%%                                                                           %%
%%         Emmanuel Coquery, projet Contraintes, INRIA Rocquencourt          %%
%%                                                                           %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% $Header: /home/beaune/contraintes/coquery/cvs/contraintes/tclpchr/lib/ISO/corelib.typ,v 1.1 2002/06/26 08:43:49 coquery Exp $

%% Note that definitions for clauses layout are asserted in first position.
%% This means that the lastest ones are considered before the first ones,
%% which  is the reverse order w.r.t. standard prolog approch.
%% This is intended to allow one to refine later a clause layout definition

% directives
:- tclp__define_clause((:- Body),Location,[],[Body-BodyLocation],
                       (user:args_location(Location,[BodyLocation]))).

% standard clauses
:- tclp__define_clause((Head :- Body),Location,
                       HeadDef,[Body-BodyLoc],
                       (
                         user:args_location(Location,[HeadLoc,BodyLoc]),
                         tclp__clause(Head,HeadLoc,HeadDef,[])
                       )).

% allow the user to load some prolog definitions for tclp
:- tclp__executable(tclp__load_prolog(_)).
:- tclp__add_hook(tclp__load_prolog(Files),consult(Files)).
